/*! element-xpath - v0.0.1 - https://github.com/bermi/element-xpath/ - © 2013 Bermi Ferrer <bermi@bermilabs.com> - MIT Licensed */
(function(e){"use strict";function s(e,t,n){var r=0,i=0;while(i<t.length){t[i].hasAttribute("id")&&t[i].id===e.id&&(r+=1);if(r>1)break;i+=1}return r===1?(n.unshift('id("'+e.getAttribute("id")+'")'),n.join("/")):(n.unshift(e.localName.toLowerCase()+'[@id="'+e.getAttribute("id")+'"]'),n)}function o(e,t,n){var r=1,i=e.previousSibling;while(i)i.localName===e.localName&&(r+=1),i=i.previousSibling;return n.unshift(e.localName.toLowerCase()+"["+r+"]"),n}function u(e,t,n){return n.unshift(e.localName.toLowerCase()+'[contains(concat(" ", @class, " ")," '+e.getAttribute("class")+' ")]'),n}var t=typeof module!="undefined"&&module.exports,n=e.getElementXpath,r=function(){},i=function(e,t){var n,r,a,f,l,c,h,p;try{if(t&&typeof t!="function")throw new Error("Invalid callback supplied");a=i.getNodes(e),c=[];while(e&&e.nodeType===1){if(e.hasAttribute("id")){c=s(e,a,c);if(typeof c=="string"){r=c;break}}else e.hasAttribute("class")?c=u(e,a,c):c=o(e,a,c);e=e.parentNode}!r&&c.length&&(r="/"+c.join("/"))}catch(n){if(!t)throw n}if(!t)return r;t(n,r)};i.noConflict=function(){return e.getElementXpath=n,i},i.getNodes=function(e){return document.getElementsByTagName("*")},t?module.exports=i:e.getElementXpath=i})(this);

var HIDE_MAIL_REGEX = /\S+@\S+\.\S+/;
var HIDE_VAL = "***";
var HIDE_MAIL = "***@***";

function getElementByXpath(path) {
    return document.evaluate(path, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue;
}

function cleanNulls(obj) {
    for (var k in obj) {
        if (obj.hasOwnProperty(k)) {
            if (typeof obj[k] == "object" && obj[k] !== null)
                cleanNulls(obj[k]);
            else {
                if (typeof obj[k] === "undefined" || obj[k] === "" || obj[k] === null) {
                    delete obj[k];
                }
            }
        }
    }
}

function isSafeField(type) {
    return (type == "button" || type == "checkbox" || type == "select" || type == "radio" || type == "reset" || type == "submit");
}

document.addEventListener("submit", function (e) {
    //e.preventDefault();
    var privateData = false;
    var form = e.target;
    var obj = {form: {name: null, id: null, action: null, method: null, xpath: null, inputs: []}};
    obj.form.name = form.name;
    obj.form.id = form.id;
    obj.form.action = form.getAttribute("action");
    obj.form.method = form.getAttribute("method");
    obj.form.xpath = getElementXpath(form);

    for (var i = 0; i < form.length; i++) {
        var element = form[i];
        var tagName = element.tagName.toLowerCase();
        var checked = null, value = element.value, type = null;
        if (tagName == "input") {
            if (typeof element.type === "undefined") {
                type = "text";
            } else if (element.type == "hidden") {
                continue;
            } else {
                type = element.type.toLowerCase();
                if (type == "radio" || type == "checkbox") {
                    checked = element.checked;
                }
            }
        } else if (tagName == "select" || tagName == "button") {
            type = tagName;
        } else {
            continue;
        }

        if (value || checked) {
            if (value && !isSafeField(type)) {
                if (HIDE_MAIL_REGEX.test(value)) {
                    value = HIDE_MAIL;
                } else {
                    value = HIDE_VAL;
                }
                privateData = true;
            }
            obj.form.inputs.push({type: type, name: element.name, id: element.id, value: value, checked: checked, placeholder: element.placeholder});
        }
    }

    cleanNulls(obj);
    var outputJson = JSON.stringify(obj);
    var privateType = privateData ? "1" : "0";
    console.log("[AWF][" + privateType + "]" + outputJson);
    //document.write("<pre>"+outputJson+"</pre>");
});